package com.okseby.engine;

import java.awt.image.DataBufferInt;

import com.okseby.engine.gfx.Image;

public class Renderer {
    private int pW, pH;
    private int[] p;
    
    public Renderer() {
        pW = Window.width;
        pH = Window.height;
        p = ((DataBufferInt)Window.pixels.getRaster().getDataBuffer()).getData();
    }

    public void test() {
        for (int i = 0; i < p.length; i++) {
            p[i] += i;
        }
    }

    public void clear() {
        for (int i = 0; i < p.length; i++) {
            p[i] = 0;
        }
    }

    public void setPixel(int x, int y, int value) {
        if ((x < 0 || x >= pW || y < 0 || y >= pH) || value == 0xffff00ff) {
            return;
        }

        p[x + y * pW] = value;
    }

    public void drawImage(Image image, int offX, int offY) {
        int xAdjust = 0;
        int yAdjust = 0;
        int widthAdjust = image.getW();
        int heightAdjust = image.getH();

        if (offX < -image.getW()) { return; }

        if (offY < -image.getH()) { return; }

        if (offX >= pW) { return; }

        if (offY >= pH) { return; }

        if (offX < 0) {
            xAdjust -= offX;
        }

        if (offY < 0) {
            yAdjust -= offY;
        }

        if (widthAdjust + offX >= pW) {
            widthAdjust -= widthAdjust + offX - pW;
        }

        if (heightAdjust + offY >= pH) {
            heightAdjust -= heightAdjust + offY - pH;
        }
        
        for (int y = yAdjust; y < heightAdjust; y++) {
            for (int x = xAdjust; x < widthAdjust; x++) {
                setPixel(x + offX, y + offY, image.getP()[x + y * image.getW()]);
            }
        }
    }
}