package com.okseby.engine;

import java.awt.BorderLayout;
import java.awt.Canvas;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.image.BufferStrategy;
import java.awt.image.BufferedImage;

import javax.swing.*;

public class Window {
    static JFrame window = new JFrame();

    static int width = 800;
    static int height = 600;
    static int scale = 1;
    static String title = "pixels | v0.03";

    static BufferedImage pixels = new BufferedImage(width, height, BufferedImage.TYPE_INT_RGB);
    static Canvas viewport = new Canvas();
    static BufferStrategy bs;
    static Graphics g;

    public static void update() {
        g.drawImage(pixels, 0, 0, width, height, null);
        bs.show();
    }

    public void create() {
        window.setSize(width * scale, height * scale);
        window.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        window.setLayout(new BorderLayout());
        window.add(viewport, BorderLayout.CENTER);
        window.setResizable(false);
        window.setLocationRelativeTo(null);
        window.setTitle(title);
        window.setVisible(true);

        Dimension s = new Dimension(width * scale, height * scale);
        viewport.setPreferredSize(s);
        viewport.setMaximumSize(s);
        viewport.setMinimumSize(s);

        viewport.createBufferStrategy(2);
        bs = viewport.getBufferStrategy();
        g = bs.getDrawGraphics();
    }
}